<template src="./template.html"></template>

<script lang="ts">
import _, { forEach, truncate, values } from "lodash";
import { Component, Vue, Watch } from "nuxt-property-decorator";
import { apiErrorHandler } from "~/utils/apiHanlers";
import { getTimeZone, getUnixFrom, getUnixTo } from "~/utils/timeZone";
var momentz = require("moment-timezone");
var moment = require("moment");
@Component({
  components: {
    RecentMarketing: () => import("./RecentMarketing/index.vue"),
    RealtimeAnalytics: () => import("./RealtimeAnalytics/index.vue"),
    Revenue: () => import("./Revenue/index.vue"),
  },
})
export default class DashboardComponent extends Vue {
  menuDateTo = false;
  menuDateFrom = false;
  filterDateFrom = momentz().startOf("month").format("YYYY-MM-DD");
  filterDateTo = momentz().endOf("month").format("YYYY-MM-DD");
  // tab = 0;
  get tab() {
    return this.$store.state.home.tab;
  }

  set tab(value: number) {
    this.$store.commit("home/setTab", value);
  }

  series: any = [
    {
      name: "Revenue",
      data: [],
    },
  ];

  listBestSeller = [];
  listLastOrder = [];
  dateEndPicker = false;
  loadingStats = false;
  get timeActive() {
    return this.$store.state.setting.timeActive;
  }

  set timeActive(value: string) {
    this.$store.commit("setting/setTimeActive", value);
  }

  get timezone() {
    return this.$store.state.setting.timezone;
  }

  get from() {
    return this.$store.state.setting.from;
  }

  get to() {
    return this.$store.state.setting.to;
  }

  get config() {
    return this.$store.state.home.config;
  }

  set config(value: any) {
    this.$store.commit("home/setConfig", value);
  }

  get loadingRevenueTable() {
    return this.$store.state.home.loadingRevenueTable;
  }

  set loadingRevenueTable(value: boolean) {
    this.$store.commit("home/setLoadingRevenueTable", value);
  }

  currentDate = "";
  dateStart = momentz().startOf("month").format("YYYY-MM-DD");
  dateEnd = moment().endOf("day").format("YYYY-MM-DD");
  currentDateTime = moment().format("YYYY-MM-DD");

  getCurrentDate() {
    this.currentDate = momentz
      .tz(this.timezone)
      .format("hh:mm A DD MMM YYYY, z Z");
  }

  get revenueTab() {
    return this.$store.state.home.revenueTab;
  }

  get dateArr() {
    return this.$store.state.setting?.dateArr || [];
  }

  set dateArr(value: string[]) {
    this.$store.commit("setting/setDateArr", value);
  }

  totalPage = 0;
  disabledButtonDate = false;

  async onFilterByTime(time: string) {
    this.$store.commit("setting/setFilterByTime", { time });
    this.disabledButtonDate = true;
    await Promise.all([this.onGetStats(), this.checkTab()]);
    this.disabledButtonDate = false;
  }

  created() {
    this.$store.commit("manageStats/setStatsEachPage", "seller-dashboard");
  }

  mounted() {
    this.onFilterByTime("Today");
    this.getCurrentDate();
  }

  loadingTableRecent = false;
  loadingTableRealTime = false;

  onRefresh() {
    this.onFilterByTime("Today");
  }

  async onGetListRecent() {
    try {
      this.loadingTableRecent = true;
      this.$store.commit("home/setListRecent", {});
      const response = await this.$api.stats.statsAnalyticsRecent({
        ...this.config,
        from: this.from || this.dateStart,
        to: this.to || this.dateEnd,
        timezone: this.timezone,
      });
      if (response?.data) {
        this.$store.commit("home/setListRecent", response.data);
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingTableRecent = false;
    }
  }

  onSort() {}

  async onGetAnalyticsRealtime() {
    try {
      this.loadingTableRealTime = true;
      this.$store.commit("home/setListRealtime", {});
      const response = await this.$api.stats.getRealTimeAnalytics({
        ...this.config,
        from: this.from || this.dateStart,
        to: this.to || this.dateEnd,
        timezone: this.timezone,
      });
      if (response?.data?.data) {
        this.$store.commit("home/setListRealtime", response.data.data);
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingTableRealTime = false;
    }
  }

  async onGetListRevenueDomain() {
    try {
      this.loadingRevenueTable = true;
      const response = await this.$api.stats.revenueDomain({
        ...this.config,
        from: this.from || this.dateStart,
        to: this.to || this.dateEnd,
        timezone: this.timezone,
      });
      if (response?.data) {
        const { total } = response;
        this.totalPage = Math.ceil(total / this.config.limit);
        this.$store.commit("home/setListRevenueDomain", response.data);
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingRevenueTable = false;
    }
  }
  async onGetListRevenueSeller() {
    try {
      this.loadingRevenueTable = true;

      const response = await this.$api.stats.revenueSeller({
        ...this.config,
        from: this.from || this.dateStart,
        to: this.to || this.dateEnd,
        timezone: this.timezone,
      });
      if (response?.data) {
        const { total } = response;
        this.totalPage = Math.ceil(total / this.config.limit);
        this.$store.commit("home/setListRevenueSeller", response.data);
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingRevenueTable = false;
    }
  }
  async onGetListRevenueDate() {
    try {
      this.loadingRevenueTable = true;

      const response = await this.$api.stats.revenueDate({
        ...this.config,
        from: this.from || this.dateStart,
        to: this.to || this.dateEnd,
        timezone: this.timezone,
      });
      if (response?.data) {
        const { total } = response;
        response.data.forEach((item: any) => {
          item.minusRevenue = this.$utils.formatCurrencyFloat(
            item.revenueTotal - item.revenue
          );
          item.refund = this.$utils.formatCurrencyFloat(
            item.revenueTotal - item.revenue
          );
        });
        this.totalPage = Math.ceil(total / this.config.limit);
        this.$store.commit("home/setListRevenueDate", response.data);
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingRevenueTable = false;
    }
  }

  async onGetListRevenueProduct() {
    try {
      this.loadingRevenueTable = true;

      const response = await this.$api.stats.revenueProduct({
        ...this.config,
        from: this.from || this.dateStart,
        to: this.to || this.dateEnd,
        timezone: this.timezone,
      });
      if (response?.data) {
        const { total } = response;
        this.totalPage = Math.ceil(total / this.config.limit);
        this.$store.commit("home/setListRevenueProduct", response.data);
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingRevenueTable = false;
    }
  }

  async onGetListRevenueHour() {
    try {
      this.loadingRevenueTable = true;

      const response = await this.$api.stats.revenueHour({
        ...this.config,
        from: this.from || this.dateStart,
        to: this.to || this.dateEnd,
        timezone: this.timezone,
      });
      if (response?.data) {
        const { total } = response;
        this.totalPage = Math.ceil(total / this.config.limit);
        this.$store.commit("home/setListRevenueHour", response.data);
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingRevenueTable = false;
    }
  }

  async onGetListRevenueMonth() {
    try {
      this.loadingRevenueTable = true;

      const response = await this.$api.stats.revenueMonth({
        ...this.config,
        from: this.from || this.dateStart,
        to: this.to || this.dateEnd,
        timezone: this.timezone,
      });
      if (response?.data) {
        const { total } = response;
        this.totalPage = Math.ceil(total / this.config.limit);
        this.$store.commit("home/setListRevenueMonth", response.data);
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingRevenueTable = false;
    }
  }

  get dateRangeText() {
    return this.dateArr.join("~");
  }

  async onSearchByDate() {
    if (this.dateRangeText.split("~").length < 2) {
      return this.$pushNotification.error("Please select 2 days or date range");
    }
    this.$store.commit("setting/setTime", {
      dateStart: this.dateRangeText.split("~")[0],
      dateEnd: this.dateRangeText.split("~")[1],
    });

    this.disabledButtonDate = true;
    await Promise.all([this.onGetStats(), this.checkTab()]);
    this.disabledButtonDate = false;

    this.timeActive = "";
  }

  intervalAnalyticsRealtime: any = 0;

  checkTab() {
    if (this.tab == 0) {
      this.onGetListRecent();
      clearInterval(this.intervalAnalyticsRealtime);
    }
    if (this.tab == 1) {
      this.onGetAnalyticsRealtime();
      this.intervalAnalyticsRealtime = setInterval(
        this.onGetAnalyticsRealtime,
        60000
      );
    }
    if (this.tab == 2) {
      this.checkRevenueTab();
      clearInterval(this.intervalAnalyticsRealtime);
    }
  }
  checkRevenueTab() {
    if (this.tab == 2) {
      if (this.revenueTab == 0) {
        this.onGetListRevenueDomain();
      }
      if (this.revenueTab == 1) {
        this.onGetListRevenueDate();
      }
      if (this.revenueTab == 2) {
        this.onGetListRevenueSeller();
      }
      if (this.revenueTab == 3) {
        this.onGetListRevenueProduct();
      }
      if (this.revenueTab == 4) {
        this.onGetListRevenueHour();
      }
      if (this.revenueTab == 5) {
        this.onGetListRevenueMonth();
      }
    }
  }

  stats = {};

  async onGetStats() {
    try {
      this.loadingStats = true;
      this.stats = {};
      const response = await this.$api.stats.statsByTime({
        ...this.config,
        from: this.from,
        to: this.to,
        timezone: this.timezone,
      });
      if (response?.data) {
        this.stats = response.data;
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingStats = false;
    }
  }

  @Watch("revenueTab")
  callApiWhenChangeTab() {
    this.checkRevenueTab();
  }

  @Watch("tab")
  callApiMarketingTab() {
    this.checkTab();
  }
}
</script>

<style scoped lang="scss">
p {
  margin-bottom: 0;
}
.v-tab--active {
  p,
  i {
    color: #076ce3;
  }
}
// .filter-btns_last_month {
//   @media (max-width: 1138px) {
//     margin-right: 0 !important;
//   }
// }
</style>
